package infoh509.tp3.jdom.ex3;

import org.xml.sax.Attributes;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

public class DBLP extends DefaultHandler {
	private int books = 0;
	private int proceedings = 0;
	private int inproceedings = 0;
	
	public void startElement(String uri, String localName,
			String qName, Attributes atts) {

		
		
		/* si l'element est une commande, compte cette commande */
		if (localName.equals("book")) {
			books++;
		}
		else if (localName.equals("inproceedings")) {
			inproceedings++;
		}
		else if (localName.equals("proceedings")) {
			proceedings++;
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		XMLReader reader;
		try {
			DBLP myHandler = new DBLP();
			
			/* Read the file passed as parameter using SAX */
			reader = XMLReaderFactory.createXMLReader();
			reader.setContentHandler(myHandler);
			reader.parse("data/dblp.xml");
			
			/* Loading the file using JDOM is impractical. Indeed, DBLP contains
			 * >400Mb of data and there is a non negligible overhead incurred 
			 * for the in memory representation of the JDOM tree. */
			
			System.out.println("Books: " + myHandler.books);
			System.out.println("Proceedings: " + myHandler.proceedings);
			System.out.println("In proceedings: " + myHandler.inproceedings);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
