package infoh509.tp3.sax.ex1;

import java.util.HashSet;
import java.util.Set;

import org.xml.sax.Attributes;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

public class Exercice3 extends DefaultHandler {
	private Set<String> countries = new HashSet<String>();
	private boolean shippingCountry = false;
	
	public void startElement(String uri, String localName,
			String qName, Attributes atts) {

		/* On veut les pays de livraison */
		if (localName.equals("ShipCountry")) {
			shippingCountry = true;
		}
	}

	public void endElement(String uri, String localName, 
			String qName) {
		
		/* Fin de l'element, on ne veut plus garder le contenu */
		if (localName.equals("ShipCountry")) {
			shippingCountry = false;
		}
	}

	public void characters(char[] ch, int start, int length) {
		String text = new String(ch,start,length);

		/* Si on s'interesse au contenu de l'element, on le conserve 
		 * Noter que rien ne garanti qu'on obtienne l'ensemble des caracteres d'une
		 * seule fois. Il est en general preferable de construire une chaine 
		 * par concatenations successives et de s'en servir dans endElement.
		 */
		
		if (shippingCountry) {
			if (!countries.contains(text)) {
				System.out.println(text);
				countries.add(text);
			}
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		XMLReader reader;
		try {
			Exercice3 myHandler = new Exercice3();
			
			/* Read the file passed as parameter using SAX */
			reader = XMLReaderFactory.createXMLReader();
			reader.setContentHandler(myHandler);
			reader.parse("data/orders.xml");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
